#include <stdio.h>
#include <avr\io.h>
#include <avr\interrupt.h>
//#include <avr/pgmspace.h> 

#define DIM_LABIRINT 10
#define ERR1 10
#define DELTA_R 0.5
#define NORMALA_X 198
#define NORMALA_Y 198
struct segment {
	int x[2];
	int y[2];
};


/************************************************************************ 
 * REDIRECTARE stdin, stdout pentru receptie, transmisie seriala
 ************************************************************************/
int uart_putchar(char c, FILE *unused);
int uart_getchar(FILE* f);
FILE mystdout = FDEV_SETUP_STREAM(uart_putchar, NULL, _FDEV_SETUP_WRITE);
FILE mystdin =  FDEV_SETUP_STREAM(NULL, uart_getchar, _FDEV_SETUP_READ);


int paritate = 0;
int t = 0;
float x_old, x_new, y_old, y_new;
int val_x, val_y;
uint8_t channel_x = 0, channel_y = 0;
struct segment labirint[DIM_LABIRINT];

int ADC_get(uint8_t channel)
{
	//TODO
	//setati canalul de pe care vreti sa faceti citirea
	//asteptati sa se termine o conversie
	//returnati rezultatul conversiei
	ADMUX |= channel;
	
	ADCSRA |= (1<<ADSC);
	loop_until_bit_is_set(ADCSRA, ADIF);
	return ADC;
	
}

int ADC_get2(uint8_t channel)
{

	//TODO
	ADMUX &= ~31;
	ADMUX |= channel;
	
	while( ! ADCSRA & (1 << ADIF) );
	
	return ADC;
}

void ADC_init2(void)
{
	//TODO
	// AVCC with external capacitor at AREF pin
	
	ADMUX |= (1 << REFS0);
	ADMUX &= ~(1 << REFS1);
	
	// activeaza ADC si il pune in modul free running (auto trigger). Prescaler de ceas la maximum. FARA intrerupere la conversie completa.
	
	ADCSRA |= (1 << ADEN);
	ADCSRA |= (1 << ADATE);
	ADCSRA |= (7 << ADPS0);
	ADCSRA &= ~(1 << ADIE);
	ADCSRA |= (1 << ADSC);
	
		
}

void ADC_init(void)
{
	//TODO
	//referinta AVCC cu condesator extern pe pinul AREF;
	// activeaza ADC si il pune in modul free running (auto trigger). Prescaler de ceas la maximum. FARA intrerupere la conversie completa.
	
	ADMUX = (1<<REFS0);
	ADCSRA |= (1<<ADATE)| (1<<ADEN)| (1<<ADPS2)| (1<<ADPS1) |(1<<ADPS0);
}

void USART_init(void)
{
	//TODO
	// Initializare modul USART pt comunicatie la 9600bps, 8 biti de date, la 16MHz											
	UCSRB = (1<<RXEN)|(1<<TXEN);
	UCSRC = (1<<URSEL)|(1<<UCSZ1)|(1<<UCSZ0);
	//UBRRH = 0;
	UBRRL = 8;
	
}

void Timer1_init(void)
{
// Initializare timer 1 compare match A pentru a avea un timer la nivel de jumatate de secunda, 16MHz
	OCR1A = 15624 / 12;
	TCCR1A = 0;
	TCCR1B = (1<<WGM12)|(1<<CS12)|(1<<CS10);
	TIMSK |= _BV(OCIE1A);
}
/************************************************************************ 
 * Vectorul de intreruperi... 
 ************************************************************************/
 void setX(char value){
	printf("%c", 0x7C);
	printf("%c", 0x18);
	printf("%c", value);
}

void setY(char value){
	printf("%c", 0x7C);
	printf("%c", 0x19);
	printf("%c", value);
}
 
 void setBackgroundBrightness(char value){	// value in [0, 100]
	printf("%c", 0x7C);
	printf("%c", 0x02);
	printf("%c", value);
}

void clearScreen(){
	printf("%c", 0x7C); 
	printf("%c", 0x00);
}

void demo(){
	printf("%c", 0x7C);
	printf("%c", 0x04);
}



void setPixel(char state){
	printf("%c", 0x50);
	printf("%c", 0x40);
	printf("%c", state);
}

void drawLine(char startX, char startY, char endX, char endY, char state){
	printf("%c", 0x7C); 
	printf("%c", 0x0C);
	printf("%c", startX);
	printf("%c", startY);
	printf("%c", endX);
	printf("%c", endY);
	printf("%c", state);
}

void drawCircle(char startX, char startY, char radius, char state){
	printf("%c", 0x7C);
	printf("%c", 0x03);
	printf("%c", startX);
	printf("%c", startY);
	printf("%c", radius);
	printf("%c", state);
}

void drawBox(char topLeftX, char topLeftY, char bottomRightX, char bottomRightY, char state){
	printf("%c", 0x7C);
	printf("%c", 0x0F);
	printf("%c", topLeftX);
	printf("%c", topLeftY);
	printf("%c", bottomRightX);
	printf("%c", bottomRightY);
	printf("%c", state);
}

void init_labirint(void)
{	

	// linii verticale
	labirint[0].x[0]	=  	1;
	labirint[0].y[0]	= 	0;
	labirint[0].x[1]	= 	1;
	labirint[0].y[1]	= 	63;
	
	labirint[1].x[0]	= 	40;
	labirint[1].y[0]	= 	40;
	labirint[1].x[1]	= 	40;
	labirint[1].y[1]	= 	63;
	
	labirint[2].x[0]	= 	65;
	labirint[2].y[0]	= 	40;
	labirint[2].x[1]	= 	65;
	labirint[2].y[1]	= 	50;
	
	labirint[3].x[0]	= 	90;
	labirint[3].y[0]	= 	40;
	labirint[3].x[1]	= 	90;
	labirint[3].y[1]	= 	63;
	
	labirint[4].x[0]	= 	125;
	labirint[4].y[0]	= 	0;
	labirint[4].x[1]	= 	125;
	labirint[4].y[1]	= 	63;


	// linii orizontale
	labirint[5].x[0]	= 	0;
	labirint[5].y[0]	= 	0;
	labirint[5].x[1]	= 	125;
	labirint[5].y[1]	= 	0;
	
	labirint[6].x[0]	= 	25;
	labirint[6].y[0]	= 	20;
	labirint[6].x[1]	= 	105;
	labirint[6].y[1]	= 	20;

	labirint[7].x[0]	= 	40;
	labirint[7].y[0]	= 	40;
	labirint[7].x[1]	= 	65;
	labirint[7].y[1]	= 	40;
	
	labirint[8].x[0]	= 	1;
	labirint[8].y[0]	= 	63;
	labirint[8].x[1]	= 	40;
	labirint[8].y[1]	= 	63;
	
	labirint[9].x[0]	= 	55;
	labirint[9].y[0]	= 	63;
	labirint[9].x[1]	= 	125;
	labirint[9].y[1]	= 	63;

}

void deseneaza_labirint(int ink)
{
	int i;
	for (i = 0; i < DIM_LABIRINT; i++) {
			drawLine(labirint[i].x[0], labirint[i].y[0], labirint[i].x[1], labirint[i].y[1], ink);
	}
}

int k;
int verificare_labirint(int xcheck, int ycheck)
{

	//printf("%c", 'b');
	int i;
	
	return 1;
	for (i = 0; i < DIM_LABIRINT; i++) {
		if (labirint[i].x[0] == labirint[i].x[1]) {
			int y1 = labirint[i].y[0];
			int y2 = labirint[i].y[1];
			int ymin = y1 < y2 ? y1 : y2;
			int ymax = y1 > y2 ? y1 : y2;
			
			if (((xcheck > labirint[i].x[0] -3 )&& (xcheck < labirint[i].x[0] + 3)) &&
				((ycheck > ymin - 3) && (ycheck < ymax + 3))) {
				//printf("%c", 'A' + k);
				k++;
				return 0;
				}
		}

		
	/*	if (labirint[i].y[0] == labirint[i].y[1]) {
			int x1 = labirint[i].y[0];
			int x2 = labirint[i].y[1];
			int xmin = x1 < x2 ? x1 : x2;
			int xmax = x1 > x2 ? x1 : x2;
			
			
		} */
	}
	
	return 1;
}

// Exemplu de functie ce se apeleaza la interval de 1 secunda, intrerupere generata de timerul 1 (vezi laboratorul 2) 
SIGNAL(SIG_OUTPUT_COMPARE1A)
{	
	// Cod ce se apeleaza 1 data pe secunda
	
	uint8_t i;
	
	if (paritate) {
		val_x = ADC_get2(channel_x); //citim valoarile de la accelerometru
		
		setX(0);
		setY(60);
		printf("X:%d ", val_x); //afisam valoarea citita
	}
	
	else {
		val_y = ADC_get2(channel_y);
		
		setX(0);
		setY(50);
		printf("Y:%d ", val_y);
	}
	
	paritate = !paritate;

	

	//drawLine(0, 0, 50, 30, 1);
	//drawLine(0, 0, 50, 30, 0);
	
	
	if (val_x < NORMALA_X - ERR1) {
		x_new = x_old + DELTA_R;
		/*if (!verificare_labirint((int)x_new, (int)y_new)) {
			x_new = x_old;
		} */
	}
	
	else if (val_x > NORMALA_X + ERR1) {
		x_new = x_old - DELTA_R;
		/*if (!verificare_labirint((int)x_new, (int)y_new)) {
			x_new = x_old;
		} */
	}
	
	else {
		x_new = x_old;
	}
	
	if (val_y < NORMALA_Y - ERR1) {
		y_new = y_old + DELTA_R;
		/*if (!verificare_labirint((int)x_new, (int)y_new)) {
			y_new = y_old;
		}*/
	}
	
	else if (val_y > NORMALA_Y + ERR1) {
		y_new = y_old - DELTA_R;
		/*if (!verificare_labirint((int)x_new, (int)y_new)) {
			y_new = y_old;
		}*/
	}
	
	else {
		y_new = y_old;
	}
	
	if (t == 40) {
		clearScreen();
		deseneaza_labirint(1);
		t = 0;
	}
	t++;
	
	drawCircle((int)x_old, (int)y_old, 3, 0);
	drawCircle((int)x_new, (int)y_new, 3, 1);
	
	x_old = x_new;
	y_old = y_new;

}
/*
lvr
*/
//printf("%c", );

/*
int checkMaze(int xcheck, int ycheck)
{
	int i = 0;
	for (i = 0; i < MAZELEN; i++)
		if (maze[i][0] == maze[i][2])
		{
			int y1 = maze[i][1];
			int y2 = maze[i][3];
			int ymin = y1 < y2 ? y1 : y2;
			int ymax = y1 > y2 ? y1 : y2;
			
			if (((xcheck > maze[i][0] -3 )&& (xcheck < maze[i][0] + 3)) &&
				((ycheck > ymin - 3) && (ycheck < ymax + 3)))
				return 0;
		}
	return 1;
}
*/



/************************************************************************ 
 * PROGRAMUL PRINCIPAL
 ************************************************************************/
int main(void)
{
	uint8_t key;
	
	USART_init();
	
	stdin = &mystdin;
	stdout = &mystdout;

	ADC_init2();
	
	Timer1_init();
	
	channel_x = 6;
	channel_y = 5;
	
	x_new = x_old = 7;
	y_new = y_old = 50;
	
	
	
		
	cli(); //oprim sistemul de intreruperi (timerul e inactiv pana cand selectam canalul la ADC)
	
	//printf("\nEnter ADC channel(0-7): ");
	//scanf("%d",&channel);

	
	//printf("\nReading ADC channel %d. Press 'q' to stop.", channel);
	
	clearScreen();
	init_labirint();
	deseneaza_labirint(1);
	drawCircle((int)x_old, (int)y_old, 3, 1);
	sei(); //dam drumul la "threadul" SIGNAL(SIG_OUTPUT_COMPARE1A) care va face citirea de la ADC odata pe secunda
	
	//printf("%c", 0x7C);
	//printf("%c", 0x04);
	
	//drawBox(10, 10, 70, 70, 1);
	
/*		setBackgroundBrightness(20);
	clearScreen();
	drawCircle(50, 50, 7, 1);
	drawLine(0, 0, 50, 30, 1);
	
	drawBox(10, 50, 80, 10, 1);
	drawBox(20, 40, 50, 20, 0);
*/	
	//drawBox(100, 10, 170, 170, 1);
	while(1);
	
    return 0;
}


/************************************************************************ 
 * IMPLEMENTARE FUNCTII TRANSMISIE/RECEPTIE SERIALA, pentru mapare stdin, stdout
 ************************************************************************/
// Functie ce trateaza trimiterea unui caracter pe seriala
int uart_putchar(char c, FILE *unused)      
{
	if (c == '\n')
		uart_putchar('\r', 0);
	loop_until_bit_is_set(UCSRA, UDRE);
	UDR = c;
	return 0;
}

// Functie ce trateaza primirea unui caracter pe seriala
int uart_getchar(FILE* f)
{
	char c;
    
    loop_until_bit_is_set(UCSRA, RXC);
    c = UDR;
    if(c=='\r')
		c='\n';
    uart_putchar(c,NULL); 
    return c;
}



